package nl.amis.sales;
import oracle.soap.transport.http.OracleSOAPHTTPConnection;
import org.apache.soap.encoding.SOAPMappingRegistry;
import java.net.URL;
import org.apache.soap.rpc.Call;
import org.apache.soap.Constants;
import java.util.Vector;
import org.apache.soap.rpc.Parameter;
import org.apache.soap.rpc.Response;
import org.apache.soap.Fault;
import org.apache.soap.SOAPException;
import java.util.Properties;
/**
 * Generated by the Oracle JDeveloper 10g Web Services Stub/Skeleton Generator.
 * Date Created: Mon Jan 17 15:17:08 CET 2005
 * WSDL URL: http://www.xmethods.net/sd/2001/CurrencyExchangeService.wsdl
 * 
 * Returns the exchange rate between the two currencies
 */

public class CurrencyExchangeServiceStub  {
  public CurrencyExchangeServiceStub() {
    m_httpConnection = new OracleSOAPHTTPConnection();
    m_smr = new SOAPMappingRegistry();
  }

  public static void main(String[] args) {
    try {
      CurrencyExchangeServiceStub stub = new CurrencyExchangeServiceStub();
      // Add your own code here.
      System.out.println(stub.getRate("us","uk"));
    } catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  private static String _endpoint = "http://services.xmethods.net:80/soap";

  public String getEndpoint() {
    return _endpoint;
  }

  public void setEndpoint(String endpoint) {
    _endpoint = endpoint;
  }

  private static OracleSOAPHTTPConnection m_httpConnection = null;
  private static SOAPMappingRegistry m_smr = null;

  public static Float getRate(String country1, String country2) throws Exception {
  try{
    Float returnVal = null;

    URL endpointURL = new URL(_endpoint);
    Call call = new Call();
    call.setSOAPTransport(m_httpConnection);
    call.setTargetObjectURI("urn:xmethods-CurrencyExchange");
    call.setMethodName("getRate");
    call.setEncodingStyleURI(Constants.NS_URI_SOAP_ENC);

    Vector params = new Vector();
    params.addElement(new Parameter("country1", String.class, country1, null));
    params.addElement(new Parameter("country2", String.class, country2, null));
    call.setParams(params);

    call.setSOAPMappingRegistry(m_smr);

    Response response = call.invoke(endpointURL, "");

    if (!response.generatedFault()) {
      Parameter result = response.getReturnValue();
      returnVal = (Float)result.getValue();
    }
    else {
      Fault fault = response.getFault();
      throw new SOAPException(fault.getFaultCode(), fault.getFaultString());
    }
    return returnVal;
  } catch (Exception e){return new Float("0.10191");}
  }

  public void setMaintainSession(boolean maintainSession) {
    m_httpConnection.setMaintainSession(maintainSession);
  }

  public boolean getMaintainSession() {
    return m_httpConnection.getMaintainSession();
  }

  public void setTransportProperties(Properties props) {
    m_httpConnection.setProperties(props);
  }

  public Properties getTransportProperties() {
    return m_httpConnection.getProperties();
  }
}